<template>
  <div class="flex flex-col gap-2">
    <label v-if="label" :for="attrs.id"> Test </label>
    <InputText
      v-model="value"
      v-bind="$attrs"
      :name="name"
      :rules="rules"
      :invalid="invalid"
    />
    <small v-if="errorMessage"> {{ errorMessage }} </small>
    <small v-if="small"> {{ small }} </small>
  </div>
</template>

<script lang="ts" setup>
import InputText from 'primevue/inputtext'

const attrs = useAttrs() as any
const emit = defineEmits(['update:modelValue'])

const props = defineProps({
  modelValue: {
    type: String,
    required: false,
    default: ''
  },
  label: {
    type: String,
    required: false
  },
  name: {
    type: String,
    required: true
  },
  rules: {
    type: String,
    required: false,
    default: ''
  },
  type: {
    type: String,
    required: false
  },
  small: {
    type: String,
    required: false
  },
  float: {
    type: Boolean,
    required: false
  }
})

const invalid = computed(() => (errorMessage.value ? true : false))

const { value, errorMessage } = useField(props.name, props.rules, {
  initialValue: props.modelValue,
  syncVModel: true
})
</script>
